#include "criptosistemas.h"
#include "ui_criptosistemas.h"
#include <QMessageBox>
#include<QProgressDialog>

#include <QTime>
#include <QHash>
#include <QCryptographicHash>
#include <QFile>
#include <QFileDialog>
#include <QTextStream>
#include <QDateTime>
#include <QDebug>
#include <iostream>
#include <ctime>
#include "polynomial.h"
#include "executionresult.h"
#include <crypto++/rsa.h>
#include <crypto++/osrng.h>
#include <crypto++/base64.h>
#include <crypto++/files.h>
#include <crypto++/salsa.h>

const int iterations = 20;

using namespace std;
using namespace pol;
using namespace CryptoPP;

CriptoSistemas::CriptoSistemas(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::CriptoSistemas)
{
    ui->setupUi(this);
    QFile ruta_priv;
    QFile ruta_publ;
    if ( ruta_priv.exists("keys/privkey.txt") && ruta_publ.exists("keys/pubkey.txt"))
    {
        ui->generarLlaves->setEnabled(false);
        ui->cifrar->setEnabled(true);
        ui->decifrar->setEnabled(true);
        connect(ui->cifrar,SIGNAL(clicked()),this,SLOT(CifrarArchivo()));
        ui->progressBar->setVisible(false);
    }
    else{
        connect(ui->generarLlaves,SIGNAL(clicked()),this,SLOT(OpcionLlaves()));
        connect(ui->cifrar,SIGNAL(clicked()),this,SLOT(CifrarArchivo()));
        ui->progressBar->setVisible(false);
    }
}


CriptoSistemas::~CriptoSistemas()
{
    delete ui;
}


void CriptoSistemas::OpcionLlaves()
{
    QPushButton *pushSi = new QPushButton("&Si", this);
    QPushButton *pushNo = new QPushButton("&No", this);

    QString generar_llaves = "<html><head/><body><p ><img src=':/static/cenditel.png' width='110' height='80' style='float: left;'/></p><p align='center'><span style= 'font-size:16pt; font-weight:600; font-style:italic; color:#ff0000;'>Generar Llaves</span></p></body></html>";
    ui->titulo->setText(generar_llaves);
    QString pregunta = "<html><head/><body><p align='center'><span style= 'font-size:16pt; color:#2589eb;'>¿Deseas Generar las llave privada y publica?</span></p><p align='center'><img src=':/static/llaves.png'/></p></body></html>";
    ui->imgCentral->setText(pregunta);
    pushSi->setGeometry(QRect(233, 394, 80, 31));
    pushNo->setGeometry(QRect(518, 394, 80, 31));
    ui->centralPage->addWidget(ui->imgCentral, 0,2);
    ui->centralPage->addWidget(pushSi, 1,1);
    ui->centralPage->addWidget(pushNo, 1,3);
    connect(pushSi,SIGNAL(clicked()),this,SLOT(GenerarLlaves()));
    connect(pushNo,SIGNAL(clicked()),this,SLOT(Inicio()));
    pushSi->setObjectName("si");
    pushNo->setObjectName("no");
}


void CriptoSistemas::Inicio()
{

}

void CriptoSistemas::GenerarLlaves()
{
    QFile ruta_priv;
    QFile ruta_publ;
    QPushButton *pushSi = findChild<QPushButton*>("si");
    pushSi->setVisible(false);
    QPushButton *pushNo = findChild<QPushButton*>("no");
    pushNo->setVisible(false);
    QPushButton *pushCifrar = new QPushButton("&Cifrar", this);
    QPushButton *pushDescifrar = new QPushButton("&Descifrar", this);
    pushCifrar->setObjectName("cifra");
    pushDescifrar->setObjectName("descifrar");
    QString exito = "<html><head/><body><p align='center'><span style= 'font-size:16pt; color:#2589eb;'>Éxito al generar las claves, ahora puedes cifrar o descifrar un archivo</span></p><p align='center'><img src=':/static/llaves.png'/></p></body></html>";
    if ( ruta_priv.exists("keys/privkey.txt") && ruta_publ.exists("keys/pubkey.txt"))
    {

        QMessageBox::information(this,"Informacion","Las llaves existen, las puedes usar para cifrar o descifrar un archivo!!!");
        ui->generarLlaves->setEnabled(false);
        ui->cifrar->setEnabled(true);
        ui->decifrar->setEnabled(true);
        ui->imgCentral->setText(exito);
        ui->centralPage->addWidget(ui->imgCentral, 0,2);
        ui->centralPage->addWidget(pushCifrar, 1,1);
        ui->centralPage->addWidget(pushDescifrar, 1,3);
    }
    else
    {
        QMessageBox::information(this,"Alerta","Generando la clave......!!!");
        pol_t kx = get_rand_pol(KEY_DEG, false);
        pol_t ky = get_rand_pol(KEY_DEG, false);
        pol3v_t D = get_open_key(kx, ky);
        AutoSeededRandomPool rng;
        InvertibleRSAFunction privkey;
        privkey.Initialize(rng, 1024);
        Base64Encoder privkeysink(new FileSink("keys/privkey.txt"));
        privkey.DEREncode(privkeysink);
        privkeysink.MessageEnd();
        RSAFunction pubkey(privkey);

        Base64Encoder pubkeysink(new FileSink("keys/pubkey.txt"));
        pubkey.DEREncode(pubkeysink);
        pubkeysink.MessageEnd();
        ui->generarLlaves->setEnabled(false);
        ui->cifrar->setEnabled(true);
        ui->decifrar->setEnabled(true);
        QMessageBox::information(this,"Exito","Las llaves se crearon, las puedes usar para cifrar o descifrar un archivo!!!");
        ui->imgCentral->setText(exito);
        ui->centralPage->addWidget(ui->imgCentral, 0,2);
        ui->centralPage->addWidget(pushCifrar, 1,1);
        ui->centralPage->addWidget(pushDescifrar, 1,3);
    }
    connect(pushCifrar,SIGNAL(clicked()),this,SLOT(CifrarArchivo()));
    connect(pushDescifrar,SIGNAL(clicked()),this,SLOT(DescifrarArchivo()));
}


void CriptoSistemas::CifrarArchivo()
{
    QPushButton *pushSeleccionar = new QPushButton("&Seleccionar Archivo ...", this);
    QPushButton *pushDescargar = new QPushButton("&Descargar en ...", this);
    QString cifrando = "<html><head/><body><p ><img src=':/static/cenditel.png' width='110' height='80' style='float: left;'/></p><p align='center'><span style= 'font-size:16pt; font-weight:600; font-style:italic; color:#ff0000;'>Cifrar Archivo</span></p></body></html>";
    ui->titulo->setText(cifrando);
    QString img = "<html><head/><body><p align='center'><p align='center'><img src=':/static/cifrar.png'/></p></body></html>";
    ui->imgCentral->setText(img);
    QPushButton *pushcifrar = findChild<QPushButton*>("cifra");
    QPushButton *pushDescifrar = findChild<QPushButton*>("descifrar");
    if(pushcifrar && pushDescifrar){
        pushcifrar->setVisible(false);
        pushDescifrar->setVisible(false);
    }
    ui->centralPage->addWidget(ui->imgCentral, 0,2);
    ui->centralPage->addWidget(pushSeleccionar, 0,1);
    ui->centralPage->addWidget(pushDescargar, 2,2);
    connect(pushSeleccionar, SIGNAL(clicked()), this, SLOT(OpenFolder()));


    // Cifrado
    /*
    string plain="RSA Encryption";
    FileSource file("keys/pubkey.txt", true, new Base64Decoder);
    RSAES_OAEP_SHA_Encryptor pubkey(file);
    AutoSeededRandomPool rng;
    StringSource ss1( plain, true,
        new PK_EncryptorFilter( rng, pubkey,
            new FileSink( "cifrados/data.dat" )
        ) // PK_EncryptorFilter
     ); // StringSource
    qDebug()<<"Cifrando";*/
}

QString CriptoSistemas::OpenFolder()
{
    QString dir = QFileDialog::getOpenFileName(this,tr("Select file"),"/home",tr("Files (*.txt)"));
    return dir;
}

void CriptoSistemas::DescifrarArchivo()
{

    // Descifrado
    /*
    AutoSeededRandomPool rng;
    string str;
    FileSource file("keys/privkey.txt", true, new Base64Decoder);
    FileSource cifrado("cifrados/data.dat", true, new StringSink(str));
    RSAES_OAEP_SHA_Decryptor d(file);

    StringSource ss2(str, true,
        new PK_DecryptorFilter(rng, d,
            new FileSink( "descifrados/data_des.txt" )
       ) // PK_DecryptorFilter
    ); // StringSource
    qDebug()<<"DesCifrando";*/
}


void CriptoSistemas::Ayuda()
{

}
